<?php
$wc_chart_title = '';
switch ($post_type) {
case 'post':
    $wc_chart_title = ($dt_unit == 'year') ?
        __("Words in posts by year", 'free-word-count') :
    __("Words in posts by month", 'free-word-count');
    break;
case 'page':
    $wc_chart_title = ($dt_unit == 'year') ?
        __("Words in pages by year", 'free-word-count') :
    __("Words in pages by month", 'free-word-count');
    break;
}
?>
<div class="wc-stats-chart">
  <p>
     <strong><?php echo $wc_chart_title; ?></strong>
  </p>
  <div class="wc-chart wc-datetime-chart" id="wc-<?php echo $post_type; ?>-<?php echo $dt_unit; ?>-count" ></div>
  <script type="text/javascript">
      var options = {
          chart: {
              type: 'line',
              locales: [{
<?php _e("                  name: 'en',
                  options: {
                      months: [ 'January', 'February', 'March', 'April',
                                'May', 'June', 'July', 'August',
                                'September', 'October', 'November', 'December' ],
                      shortMonths: [ 'Jan', 'Feb', 'Mar', 'Apr',
                                     'May', 'Jun', 'Jul', 'Aug',
                                     'Sep', 'Oct', 'Nov', 'Dec' ],
                      days: [ 'Sunday', 'Monday', 'Tuesday', 'Wednesday',
                              'Thursday', 'Friday', 'Saturday' ],
                      shortDays: ['Sun', 'Mon', 'Tue', 'Wed',
                                  'Thu', 'Fri', 'Sat'],
                      toolbar: {
                          menu: 'Menu',
                          exportToSVG: 'Download SVG',
                          exportToPNG: 'Download PNG',
                          exportToCSV: 'Download CSV',
                          selection: 'Selection',
                          selectionZoom: 'Selection Zoom',
                          zoomIn: 'Zoom In',
                          zoomOut: 'Zoom Out',
                          pan: 'Panning',
                          reset: 'Reset Zoom',
                      }
                  }", 'free-word-count'); ?>,
              }],
              defaultLocale: '<?php echo (substr(get_locale(), 0, 2)); ?>'
          },
          series: [{
              name: '<?php _e("Word count", "free-word-count"); ?>',
              data: [ <?php
$i = 0;
foreach (array_keys($unit_count) as $unit) {
    $yc = $unit_count[$unit];
    if ($dt_unit == 'year')
        echo "{ x: new Date('$unit-06-30').getTime(), y: $yc },";
    else
        echo "{ x: new Date('$unit-15').getTime(), y: $yc },";
}
?> ]
              }
          ],
          xaxis: {
              type: 'datetime',
              labels: {
                  formatter: function (val, opts) {
                      <?php echo $label_jscode; ?>
                  }
              }
          },
          yaxis: {
              labels: {
                  formatter: function (val, opts) {
                      return new Intl.NumberFormat().format(val);
                  }
              }
          },
          tooltip: {
              y: {
                  formatter: function (val, opts) {
                      return new Intl.NumberFormat().format(val);
                  }
              }
          }
      }
      var chart = new ApexCharts(document.querySelector("#wc-<?php echo $post_type; ?>-<?php echo $dt_unit; ?>-count"), options);
      chart.render();
  </script>
</div>
