class WordCounter {
    constructor(siteUrl, key, total) {
        this.last = 0;
        this.done = 0;
        this.intervalId = -1;
        this.progressValue = 0;
        this.baseUrl = siteUrl +
            '/wp-content/plugins/free-word-count/word-count-progress.php?' +
            'key=' + key + '&total=' + total;
        this.relocateUrl = siteUrl + '/wp-admin/admin.php?page=free-word-count';
    }

    launchInterval() {
        this.intervalId = setInterval(this.updateProgressBar.bind(this), 100);
    }

    doUpdate() {
        document.getElementById('wc-progress').value = this.progressValue;
        document.getElementById('wc-progress').childNodes[0].nodeValue =
            this.progressValue + '%';
    }

    updateProgressBar() {
        if (this.progressValue < 100) {
            let url = this.baseUrl + '&done=' + this.done + '&last=' + this.last + '?guard=X';
            var t = this;
            fetch(url)
                .then(res => res.json())
                .then(r => { t.progressValue = r['progress'];
                             t.done = r['done'];
                             t.last = r['last']; });
            this.doUpdate();
        } else {
            this.doUpdate();
            clearInterval(this.intervalId);
            window.location.replace(this.relocateUrl);
        }
    }
}

let wc = new WordCounter("<?php echo get_site_url(); ?>",
                         "<?php echo $wc_options['key']; ?>",
                         <?php echo $total; ?>);
wc.launchInterval();
