<?php
/**
 * @package Free_Word_Count
 * @version 0.0.1
 */
/*
Plugin Name: Free Word Count
Plugin URI: https://aztlan.fciencias.unam.mx/gitlab/canek/free-word-count/
Description: This FREE plugin allows count words in posts and produce reports.
Author: Canek Peláez
Version: 0.0.1
Author URI: https://aztlan.fciencias.unam.mx/~canek/
Text Domain: free-word-count
*/

define('WORD_COUNT__PLUGIN_DIR', plugin_dir_path(__FILE__));

add_action('admin_menu', 'wc_admin_menu');
function wc_admin_menu() {
    add_menu_page(__('Word count and statistics for posts and pages', 'free-word-count'),
                  __('Word count', 'free-word-count'), 'manage_options', 'free-word-count',
                  'word_count_page', 'dashicons-analytics', 90);
}

add_action('save_post', 'wc_save_post');
function wc_save_post($post_id) {
    if ($parent_id = wp_is_post_revision($post_id)) {
        $post_id = $parent_id;
    }
    $post = get_post($post_id);
    if ($post->post_status != 'publish') {
        return;
    }
    $text = strip_tags($post->post_content);
    $wc = str_word_count($text);
    update_post_meta($post_id, 'free-word-count', $wc);
}

function word_count_page() {
    if (is_file(plugin_dir_path(__FILE__) . 'page.php')) {
        include_once plugin_dir_path(__FILE__) . 'page.php';
    }
}

register_activation_hook(__FILE__, 'wc_activation');
function wc_activation($network_wide) {
	$option_name = 'word_count_options';
	$option = array('words_counted' => false,
                    'counting_words' => false);

	if (is_multisite() && $network_wide) {
		$ms_sites = function_exists('get_sites') ? get_sites() : wp_get_sites();

		if (0 < count($ms_sites)) {
			foreach ($ms_sites as $ms_site) {
				$blog_id = isset($ms_site['blog_id']) ?
                    $ms_site['blog_id'] : $ms_site->blog_id;
				switch_to_blog($blog_id);
				add_option($option_name, $option);
			}
		}
		restore_current_blog();
	} else {
		add_option($option_name, $option);
	}
}

add_action('plugins_loaded', 'wc_load_textdomain');
function wc_load_textdomain() {
    load_plugin_textdomain('free-word-count');
}
