<style>
<?php include_once WORD_COUNT__PLUGIN_DIR . '/style.css'; ?>
</style>
<?php
define('WC_ROWS_PER_PAGE', 20);
global $wpdb;

$taburl = get_site_url() . '/wp-admin/admin.php?page=free-word-count&wc-tab=';

function get_wc_tab() {
    $wc_tab = !empty($_GET["wc-tab"]) ? $_GET["wc-tab"] : 'tab-stats';
    if ($wc_tab != 'tab-stats'     && $wc_tab != 'tab-tables'    &&
        $wc_tab != 'tab-barcharts' && $wc_tab != 'tab-piecharts') {
        $wc_tab = 'tab-stats';
    }
    return $wc_tab;
}

function echoPage($type, $page, $current, $sep = ' | ', $filter = '') {
    $wc_tab = get_wc_tab();
    $url = get_site_url() . '/wp-admin/admin.php?page=free-word-count'
        . "&wc-tab=$wc_tab&wc-$type-page=$page";
    if ($filter != '') {
        $url = $url . "&wc-$type-filter=$filter";
    } else {
        $url = $url . "&guard=X";
    }
    $pi = $page + 1;
    if ($page != $current)
        echo "<a href=\"$url\">$pi</a>";
    else
        echo $pi;
    echo $sep;
}

function tab_headers($taburl = '', $selected = 'stats') {
    $tab_stats = __('Statistics', 'free-word-count');
    $tab_tables = __('Tables', 'free-word-count');
    $tab_barcharts = __('Bar charts', 'free-word-count');
    $tab_piecharts = __('Pie charts', 'free-word-count');
    $sel_st = $sel_ta = $sel_bc = $sel_pc = '';
    switch ($selected) {
    case 'stats':     $sel_st = 'selected'; break;
    case 'tables':    $sel_ta = 'selected'; break;
    case 'barcharts': $sel_bc = 'selected'; break;
    case 'piecharts': $sel_pc = 'selected'; break;
    }
    echo "<div class=\"wc-tabs-headers\">";
    echo "  <span class =\"wc-tab-header $sel_st\">";
    echo "    <a href=\"${taburl}tab-stats\">$tab_stats</a>";
    echo "  </span>";
    echo "  <span class=\"wc-tab-header $sel_ta\">";
    echo "    <a href=\"${taburl}tab-tables\">$tab_tables</a>";
    echo "  </span>";
    echo "  <span class=\"wc-tab-header $sel_bc\">";
    echo "    <a href=\"${taburl}tab-barcharts\">$tab_barcharts</a>";
    echo "  </span>";
    echo "  <span class=\"wc-tab-header $sel_pc\">";
    echo "    <a href=\"${taburl}tab-piecharts\">$tab_piecharts</a>";
    echo "  </span>";
    echo "</div>";
}

function count_again_button() {
    $value = __('Count again', 'free-word-count');
    echo "<p class=\"submit\">";
    echo "<input type=\"submit\" name=\"Recount\" " .
        "class=\"button\" value=\"$value\" />";
    echo "</p>";
}

if (!empty($_GET['Recount'])) {
    $wc_options = get_option('word_count_options');
    $wc_options['words_counted'] = false;
    $wc_options['counting_words'] = false;
    $wc_options['key'] = '';
    update_option('word_count_options', $wc_options);
}

$wc_options = get_option('word_count_options');
$do_progress_bar = false;
$total = 0;

if (!$wc_options['words_counted'] && !$wc_options['counting_words']) {
    $do_progress_bar = true;
    $wc_options['counting_words'] = true;
    $wc_options['key'] = hash('sha256', strval(rand()));
    update_option('word_count_options', $wc_options);

    $sql = $wpdb->prepare("
        SELECT count(id) AS total
        FROM {$wpdb->posts}
        WHERE post_status = %s  ", 'publish');
    $t = $wpdb->get_results($sql, OBJECT);
    $total = $t[0]->total;
}
?>

<?php if ($do_progress_bar) { ?>
<script type="text/javascript">
<?php include_once WORD_COUNT__PLUGIN_DIR . '/free-word-count.js'; ?>
</script>
<div class="progress-container">
  <h2><?php _e("Word counting in progress:", 'free-word-count'); ?></h2>
  <progress id="wc-progress" value="0" max="100">0%</progress>
</div>
<?php
} else {
    switch (get_wc_tab()) {
    case 'tab-stats':
        include_once WORD_COUNT__PLUGIN_DIR . '/tab-stats.php';
        break;
    case 'tab-tables':
        include_once WORD_COUNT__PLUGIN_DIR . '/tab-tables.php';
        break;
    case 'tab-barcharts':
        include_once WORD_COUNT__PLUGIN_DIR . '/tab-barcharts.php';
        break;
    case 'tab-piecharts':
        include_once WORD_COUNT__PLUGIN_DIR . '/tab-piecharts.php';
        break;
    }
}
?>
