<?php
$wc_page = !empty($_GET["wc-$post_type-page"]) ?
    intval($_GET["wc-$post_type-page"]) : 0;

$sql = $wpdb->prepare("
    SELECT {$wpdb->posts}.id AS id,
           {$wpdb->posts}.post_date AS date,
           {$wpdb->posts}.post_title AS title,
           CAST({$wpdb->postmeta}.meta_value AS UNSIGNED) AS word_count
    FROM {$wpdb->posts}, {$wpdb->postmeta}
    WHERE {$wpdb->posts}.id = {$wpdb->postmeta}.post_id AND
          {$wpdb->posts}.post_status = 'publish' AND
          {$wpdb->postmeta}.meta_key = 'free-word-count' AND
          {$wpdb->posts}.post_type = %s
    ORDER BY post_date", $post_type);
$results = $wpdb->get_results($sql);

$wc_total = 0;
$year_count = array();
$month_count = array();
foreach ($results as $result) {
    $year = intval(substr($result->date, 0, 4));
    $month = substr($result->date, 0, 7);
    if (!array_key_exists($year, $year_count)) {
        $year_count[$year] = 0;
    }
    if (!array_key_exists($month, $month_count)) {
        $month_count[$month] = 0;
    }
    $year_count[$year] = $year_count[$year] + $result->word_count;
    $month_count[$month] = $month_count[$month] + $result->word_count;
    $wc_total += $result->word_count;
}
?>
<div class="wc_section">
  <h3><?php echo $sec_title; ?></h3>
  <div class="wc-stats-container">
<?php
  $dt_unit = 'year';
  $unit_count = $year_count;
  $label_jscode = 'return new Date(val).getFullYear();';
  include WORD_COUNT__PLUGIN_DIR . '/datetime-chart.php';
  $dt_unit = 'month';
  $unit_count = $month_count;
  $label_jscode = 'var dt = new Date(val);' .
      'var year = dt.getFullYear();' .
      'var month = dt.getMonth()+1;' .
      'return year + "/" + (("00" + month).slice(-2));';
  include WORD_COUNT__PLUGIN_DIR . '/datetime-chart.php';
  $total_words_label = ($post_type == 'post') ?
      __('Total post words:', 'free-word-count') : __('Total page words:', 'free-word-count');
?>
  </div>
  <p>
  <strong><?php _e($total_words_label); ?></strong> <?php echo number_format($wc_total); ?>
  </p>
</div>
