<?php
$wc_page = !empty($_GET["wc-$post_type-page"]) ?
    intval($_GET["wc-$post_type-page"]) : 0;

$wc_filter = !empty($_GET["wc-$post_type-filter"]) ?
    $_GET["wc-$post_type-filter"] : '';

$base_url = get_site_url() . '/wp-content/plugins/free-word-count';

$sql = '';
if ($wc_filter == '') {
    $sql = $wpdb->prepare("
        SELECT COUNT({$wpdb->posts}.id) AS count
        FROM {$wpdb->posts}, {$wpdb->postmeta}
        WHERE {$wpdb->posts}.id = {$wpdb->postmeta}.post_id AND
              {$wpdb->posts}.post_status = 'publish' AND
              {$wpdb->postmeta}.meta_key = 'free-word-count' AND
              {$wpdb->posts}.post_type = %s", $post_type);
} else {
    $f = '%' . $wc_filter . '%';
    $sql = $wpdb->prepare("
        SELECT COUNT({$wpdb->posts}.id) AS count
        FROM {$wpdb->posts}, {$wpdb->postmeta}
        WHERE {$wpdb->posts}.id = {$wpdb->postmeta}.post_id AND
              {$wpdb->posts}.post_status = 'publish' AND
              {$wpdb->postmeta}.meta_key = 'free-word-count' AND
              {$wpdb->posts}.post_type = %s AND
              {$wpdb->posts}.post_title LIKE %s", $post_type, $f);
}
$results = $wpdb->get_results($sql);
$wc_pie_total = $results[0]->count;
$wc_pages = intval($wc_pie_total / WC_ROWS_PER_PAGE);
if ($wc_pie_total % WC_ROWS_PER_PAGE != 0)
    $wc_pages++;
if ($wc_pages < 2) {
    $wc_page = 0;
} else if ($wc_page > $wc_pages) {
    $wc_page = $wc_pages;
}

if ($wc_filter == '') {
    $sql = $wpdb->prepare("
        SELECT {$wpdb->posts}.id AS id,
               CAST({$wpdb->postmeta}.meta_value AS UNSIGNED) AS word_count,
               {$wpdb->posts}.post_title AS title
        FROM {$wpdb->posts}, {$wpdb->postmeta}
        WHERE {$wpdb->posts}.id = {$wpdb->postmeta}.post_id AND
              {$wpdb->posts}.post_status = 'publish' AND
              {$wpdb->postmeta}.meta_key = 'free-word-count' AND
              {$wpdb->posts}.post_type = %s
        ORDER by word_count DESC
        LIMIT %d, %d", $post_type, $wc_page * WC_ROWS_PER_PAGE, WC_ROWS_PER_PAGE);
} else {
    $f = '%' . $wc_filter . '%';
    $sql = $wpdb->prepare("
        SELECT {$wpdb->posts}.id AS id,
               CAST({$wpdb->postmeta}.meta_value AS UNSIGNED) AS word_count,
               {$wpdb->posts}.post_title AS title
        FROM {$wpdb->posts}, {$wpdb->postmeta}
        WHERE {$wpdb->posts}.id = {$wpdb->postmeta}.post_id AND
              {$wpdb->posts}.post_status = 'publish' AND
              {$wpdb->postmeta}.meta_key = 'free-word-count' AND
              {$wpdb->posts}.post_type = %s AND
              {$wpdb->posts}.post_title LIKE %s
        ORDER by word_count DESC
        LIMIT %d, %d", $post_type, $f, $wc_page * WC_ROWS_PER_PAGE, WC_ROWS_PER_PAGE);
}

$results = $wpdb->get_results($sql);
$n = $wpdb->num_rows;
?>
<script src="<?php echo $base_url; ?>/apexcharts/apexcharts.js"></script>
<div class="wc_section">
  <h3><?php echo $sec_title; ?></h3>
  <div class="wc-chart wc-fig-chart" id="wc-<?php echo $post_type; ?>-piechart" ></div>
  <script type="text/javascript">
var options = {
    chart: { type: 'donut' },
    series: [
<?php
$i = 0;
foreach ($results as $r) {
    echo $r->word_count;
    if (++$i < $n)
        echo ", ";
}
?>
    ],
    labels: [
<?php
$i = 0;
foreach ($results as $r) {
    $i++;
    $idx = $wc_page * WC_ROWS_PER_PAGE + $i;
    echo '"' . $idx . '. ' . addslashes($r->title) . '"';
    if ($i < $n)
        echo ", ";
}
?>
    ],
    tooltip: {
        y: {
            formatter: function (val, opts) {
                return new Intl.NumberFormat().format(val);
            }
        }
    }
}
var chart = new ApexCharts(document.querySelector("#wc-<?php echo $post_type; ?>-piechart"), options);
chart.render();
  </script>
<?php
if ($wc_pages > 1) {
    echo '<p>Page: ';
    $r2 = intval(WC_ROWS_PER_PAGE/2);
    $r4 = intval(WC_ROWS_PER_PAGE/4);
    if ($wc_pages < WC_ROWS_PER_PAGE) {
        for ($i = 0; $i < $wc_pages; $i++) {
            $sep = ($i == $wc_pages - 1) ? '' : ' | ';
            echoPage($post_type, $i, $wc_page, $sep, $wc_filter);
        }
    } else if ($wc_page - $r4 > $r4 &&
               $wc_page + $r4 < $wc_pages - $r4) {
        for ($i = 0; $i < $r4; $i++) {
            echoPage($post_type, $i, $wc_page, ' | ', $wc_filter);
        }
        echo '… | ';
        for ($i = $wc_page - $r4 + 1; $i < $wc_page + $r4 - 1; $i++) {
            echoPage($post_type, $i, $wc_page, ' | ', $wc_filter);
        }
        echo '… | ';
        for ($i = $wc_pages - $r4; $i < $wc_pages; $i++) {
            $sep = ($i == $wc_pages - 1) ? '' : ' | ';
            echoPage($post_type, $i, $wc_page, $sep, $wc_filter);
        }
        echo "<a href=\"$url\">$pi</a>";
    } else if ($wc_page - $r4 <= $r4) {
        for ($i = 0; $i < intval(3 * $r4) - 1; $i++) {
            echoPage($post_type, $i, $wc_page, ' | ', $wc_filter);
        }
        echo '… | ';
        for ($i = $wc_pages - $r4; $i < $wc_pages; $i++) {
            $sep = ($i == $wc_pages - 1) ? '' : ' | ';
            echoPage($post_type, $i, $wc_page, $sep, $wc_filter);
        }
    } else {
        for ($i = 0; $i < $r4; $i++) {
            echoPage($post_type, $i, $wc_page, ' | ', $wc_filter);
        }
        echo '… | ';
        for ($i = $wc_pages - 3 * $r4 + 1; $i < $wc_pages; $i++) {
            $sep = ($i == $wc_pages - 1) ? '' : ' | ';
            echoPage($post_type, $i, $wc_page, $sep, $wc_filter);
        }
    }
    echo '</p>';
}
?>
  </p>
  <p>
    <input type="text" name="wc-<?php echo $post_type; ?>-filter"
           size="30" />
    <input type="submit" name="<?php echo $post_type; ?>Filter" class="button"
           value="<?php _e('Filter', 'free-word-count'); ?>" />
  </p>
</div>
