<?php
$wc_page = !empty($_GET["wc-$post_type-page"]) ?
    intval($_GET["wc-$post_type-page"]) : 0;

$wc_filter = !empty($_GET["wc-$post_type-filter"]) ?
    $_GET["wc-$post_type-filter"] : '';

$sql = '';
if ($wc_filter == '') {
    $sql = $wpdb->prepare("
        SELECT COUNT(wp_posts.id) AS count
        FROM {$wpdb->posts}, {$wpdb->postmeta}
        WHERE {$wpdb->posts}.id = {$wpdb->postmeta}.post_id AND
              {$wpdb->posts}.post_status = 'publish' AND
              {$wpdb->postmeta}.meta_key = 'free-word-count' AND
              {$wpdb->posts}.post_type = %s", $post_type);
} else if (strpos($wc_filter, "cat:") === 0) {
    $cat = substr($wc_filter, 4);
    $f = '%' . $cat . '%';
    $sql = $wpdb->prepare("
        SELECT COUNT({$wpdb->posts}.id) AS count
        FROM {$wpdb->posts}, {$wpdb->postmeta}, {$wpdb->term_relationships},
             {$wpdb->term_taxonomy}, {$wpdb->terms}
        WHERE {$wpdb->posts}.id = {$wpdb->postmeta}.post_id AND
              {$wpdb->posts}.id = {$wpdb->term_relationships}.object_id AND
              {$wpdb->term_relationships}.term_taxonomy_id =
                   {$wpdb->term_taxonomy}.term_taxonomy_id AND
              {$wpdb->term_taxonomy}.term_id = {$wpdb->terms}.term_id AND
              {$wpdb->term_taxonomy}.taxonomy = 'category' AND
              {$wpdb->posts}.post_status = 'publish' AND
              {$wpdb->postmeta}.meta_key = 'free-word-count' AND
              {$wpdb->posts}.post_type = %s AND
              {$wpdb->terms}.slug LIKE %s", $post_type, $f);
} else {
    $f = '%' . $wc_filter . '%';
    $sql = $wpdb->prepare("
        SELECT COUNT({$wpdb->posts}.id) AS count
        FROM {$wpdb->posts}, {$wpdb->postmeta}
        WHERE {$wpdb->posts}.id = {$wpdb->postmeta}.post_id AND
              {$wpdb->posts}.post_status = 'publish' AND
              {$wpdb->postmeta}.meta_key = 'free-word-count' AND
              {$wpdb->posts}.post_type = %s AND
              {$wpdb->posts}.post_title LIKE %s", $post_type, $f);
}
$results = $wpdb->get_results($sql);
$wc_table_total = $results[0]->count;
$wc_pages = intval($wc_table_total / WC_ROWS_PER_PAGE);
if ($wc_table_total % WC_ROWS_PER_PAGE != 0)
    $wc_pages++;
if ($wc_pages < 2) {
    $wc_page = 0;
} else if ($wc_page > $wc_pages) {
    $wc_page = $wc_pages;
}

if ($wc_filter == '') {
    $sql = $wpdb->prepare("
        SELECT {$wpdb->posts}.id AS id,
               CAST({$wpdb->postmeta}.meta_value AS UNSIGNED) AS word_count,
               {$wpdb->posts}.post_title AS title
        FROM {$wpdb->posts}, {$wpdb->postmeta}
        WHERE {$wpdb->posts}.id = {$wpdb->postmeta}.post_id AND
              {$wpdb->posts}.post_status = 'publish' AND
              {$wpdb->postmeta}.meta_key = 'free-word-count' AND
              {$wpdb->posts}.post_type = %s
        ORDER BY word_count DESC
        LIMIT %d, %d", $post_type, $wc_page * WC_ROWS_PER_PAGE, WC_ROWS_PER_PAGE);
} else if (strpos($wc_filter, "cat:") === 0) {
    $cat = substr($wc_filter, 4);
    $f = '%' . $cat . '%';
    $sql = $wpdb->prepare("
        SELECT {$wpdb->posts}.id, {$wpdb->posts}.post_date,
               CAST({$wpdb->postmeta}.meta_value AS unsigned) AS word_count,
               {$wpdb->posts}.post_title AS title
        FROM {$wpdb->posts}, {$wpdb->postmeta}, {$wpdb->term_relationships},
             {$wpdb->term_taxonomy}, {$wpdb->terms}
        WHERE {$wpdb->posts}.id = {$wpdb->postmeta}.post_id AND
              {$wpdb->posts}.id = {$wpdb->term_relationships}.object_id AND
              {$wpdb->term_relationships}.term_taxonomy_id =
                   {$wpdb->term_taxonomy}.term_taxonomy_id AND
              {$wpdb->term_taxonomy}.term_id = {$wpdb->terms}.term_id AND
              {$wpdb->term_taxonomy}.taxonomy = 'category' AND
              {$wpdb->posts}.post_status = 'publish' AND
              {$wpdb->postmeta}.meta_key = 'free-word-count' AND
              {$wpdb->posts}.post_type = %s AND
              {$wpdb->terms}.slug like %s
        ORDER BY word_count DESC
        LIMIT %d, %d", $post_type, $f, $wc_page * WC_ROWS_PER_PAGE, WC_ROWS_PER_PAGE);
} else {
    $f = '%' . $wc_filter . '%';
    $sql = $wpdb->prepare("
        SELECT {$wpdb->posts}.id AS id,
               CAST({$wpdb->postmeta}.meta_value AS UNSIGNED) AS word_count,
               {$wpdb->posts}.post_title AS title
        FROM {$wpdb->posts}, {$wpdb->postmeta}
        WHERE {$wpdb->posts}.id = {$wpdb->postmeta}.post_id AND
              {$wpdb->posts}.post_status = 'publish' AND
              {$wpdb->postmeta}.meta_key = 'free-word-count' AND
              {$wpdb->posts}.post_type = %s AND
              {$wpdb->posts}.post_title LIKE %s
        ORDER by word_count DESC
        LIMIT %d, %d", $post_type, $f, $wc_page * WC_ROWS_PER_PAGE, WC_ROWS_PER_PAGE);
}

$results = $wpdb->get_results($sql);
$n = $wpdb->num_rows;
?>
<div class="wc_section">
  <h3><?php echo $sec_title; ?></h3>
  <table class="wc-table">
    <colgroup>
       <col span="1" style="width: 20px;" />
       <col span="1" style="width: 100px;" />
       <col span="1" style="width: 680px;" />
    </colgroup>
    <thead>
      <tr>
        <th><?php /* translators: No. as in number. */ _e('No.', 'free-word-count'); ?></th>
        <th><?php _e('Word count', 'free-word-count'); ?></th>
        <th class="left"><?php _e('Title', 'free-word-count'); ?></th>
      </tr>
    </thead>
    <tbody>
<?php
$i  = 0;
foreach ($results as $r) {
    $i++;
    $idx = $wc_page * WC_ROWS_PER_PAGE + $i;
    $rwc = number_format($r->word_count);
    $permalink = get_permalink($r->id);
    echo '<tr>';
    echo "<td class=\"center\">$idx</td>";
    echo "<td class=\"right\">$rwc</td>";
    echo "<td><a href=\"$permalink\">$r->title<a></td>";
    echo '</tr>';
}
?>
    </tbody>
  </table>
<?php
if ($wc_pages > 1) {
    echo '<div class="wc-input">';
    _e('Page: ', 'free-word-count');
    $r2 = intval(WC_ROWS_PER_PAGE/2);
    $r4 = intval(WC_ROWS_PER_PAGE/4);
    if ($wc_pages < WC_ROWS_PER_PAGE) {
        for ($i = 0; $i < $wc_pages; $i++) {
            $sep = ($i == $wc_pages - 1) ? '' : ' | ';
            echoPage($post_type, $i, $wc_page, $sep, $wc_filter);
        }
    } else if ($wc_page - $r4 > $r4 &&
               $wc_page + $r4 < $wc_pages - $r4) {
        for ($i = 0; $i < $r4; $i++) {
            echoPage($post_type, $i, $wc_page, ' | ', $wc_filter);
        }
        echo '… | ';
        for ($i = $wc_page - $r4 + 1; $i < $wc_page + $r4 - 1; $i++) {
            echoPage($post_type, $i, $wc_page, ' | ', $wc_filter);
        }
        echo '… | ';
        for ($i = $wc_pages - $r4; $i < $wc_pages; $i++) {
            $sep = ($i == $wc_pages - 1) ? '' : ' | ';
            echoPage($post_type, $i, $wc_page, $sep, $wc_filter);
        }
        echo "<a href=\"$url\">$pi</a>";
    } else if ($wc_page - $r4 <= $r4) {
        for ($i = 0; $i < intval(3 * $r4) - 1; $i++) {
            echoPage($post_type, $i, $wc_page, ' | ', $wc_filter);
        }
        echo '… | ';
        for ($i = $wc_pages - $r4; $i < $wc_pages; $i++) {
            $sep = ($i == $wc_pages - 1) ? '' : ' | ';
            echoPage($post_type, $i, $wc_page, $sep, $wc_filter);
        }
    } else {
        for ($i = 0; $i < $r4; $i++) {
            echoPage($post_type, $i, $wc_page, ' | ', $wc_filter);
        }
        echo '… | ';
        for ($i = $wc_pages - 3 * $r4 + 1; $i < $wc_pages; $i++) {
            $sep = ($i == $wc_pages - 1) ? '' : ' | ';
            echoPage($post_type, $i, $wc_page, $sep, $wc_filter);
        }
    }
    echo '</div>';
}
?>
  <div class="wc-input">
    <input type="text" name="wc-<?php echo $post_type; ?>-filter"
           class="wc-filter" />
  </div>
  <div class="wc-input">
    <input type="submit" name="<?php echo $post_type; ?>Filter"
           class="button" value="<?php _e('Filter', 'free-word-count'); ?>" />
  </dic>
</div>
