<?php

require_once __DIR__ . '/../../../wp-load.php';

$wc_options = get_option('word_count_options');
$key   = !empty($_GET['key'])   ? $_GET['key'] : '';
$total = !empty($_GET['total']) ? intval($_GET['total']) : 0;
$done  = !empty($_GET['done'])  ? intval($_GET['done']) : 0;
$last  = !empty($_GET['last'])  ? intval($_GET['last']) : PHP_INT_MAX;

header('Content-type: application/json');

$a = array();
if ($key == $wc_options['key'] &&
    $wc_options['counting_words'] &&
    current_user_can('administrator')) {

    global $wpdb;
    $results = $wpdb->get_results("
        SELECT id, post_content
        FROM {$wpdb->posts}
        WHERE post_status = 'publish' AND id > $last
        ORDER BY id LIMIT 10", OBJECT);
    $n = $wpdb->num_rows;
    if ($n > 0) {
        for ($i = 0; $i < $n; $i++) {
            $r = $results[$i];
            $last = $r->id;
            $text = strip_tags($r->post_content);
            update_post_meta($r->id, 'free-word-count', str_word_count($text));
        }

        $a['status'] = 'ok';
        $a['progress'] = intval(100.0 * floatval($done) / floatval($total));
        $a['done'] = $done + $n;
        $a['last'] = $last;

        if ($a['progress'] == 100) {
            $wc_options['words_counted'] = true;
            $wc_options['counting_words'] = false;
            $wc_options['key'] = '';
            update_option('word_count_options', $wc_options);
        }
    } else {
        $a['status'] = 'ok';
        $a['progress'] = 100;
        $a['done'] = $total;
        $a['last'] = PHP_INT_MAX;

        $wc_options['words_counted'] = true;
        $wc_options['counting_words'] = false;
        $wc_options['key'] = '';
        update_option('word_count_options', $wc_options);
    }
} else {
    $a['status'] = 'error';
    $a['message'] = 'Not authorized';
}
echo json_encode($a);
